#include <iostream>
#include <cstring>
#include <vector>
// state is (state1) (state2) (status)
// status is:
//   '-' identical (0)
//   'x' identical except string 1 ends with character x (1-26)
//   '!' permanently different (27)
// In our search we use the following metatransitions:
//                               -       x        !
//   simultaneous                -       !        !
//   lowercase on string 1       x       x        !
//   lowercase on string 2       *       !        !
//    * = we don't permit this transition
using namespace std ;
using ll = long long ;
const int MAXS = 64 ;
const int STAT = 28 ;
const int INF = 2000000000 ;
int dist[MAXS][MAXS][STAT] ;
int nextstate[MAXS][52] ;
ll havetrans[MAXS] ;
int main() {
   int s, p, t ;
   cin >> s >> p >> t ;
   vector<int> isfinal(s) ;
   for (int i=0; i<p; i++) {
      int a ;
      cin >> a ;
      a-- ;
      isfinal[a] = 1 ;
   }
   for (int i=0; i<s; i++)
      for (int j=0; j<26; j++)
         nextstate[i][j] = -1 ;
   for (int i=0; i<t; i++) {
      int a, b ;
      char sigma ;
      cin >> a >> sigma >> b ;
      a-- ; b-- ;
      int c = (sigma <= 'Z' ? (sigma - 'A') : (sigma - 'a' + 26)) ;
      nextstate[a][c] = b ;
      havetrans[a] |= 1LL<<c ;
   }
   for (int a=0; a<s; a++)
      for (int b=0; b<s; b++)
         for (int stat=0; stat<STAT; stat++)
            dist[a][b][stat] = INF ;
   dist[0][0][0] = 0 ;
   int pseen = 0 ;
   for (int tim=0; ; tim++) {
      int seen = 0 ;
      for (int s0=0; s0<s; s0++)
         for (int s1=0; s1<s; s1++)
            for (int stat=0; stat<28; stat++)
               if (dist[s0][s1][stat] == tim) {
                  seen++ ;
                  if (stat != 0 && isfinal[s0] && isfinal[s1]) {
                     cout << tim << endl ;
                     exit(0) ;
                  }
                  ll uc = (havetrans[s0] & havetrans[s1]) ;
                  while (uc) {
                     int c = ffsll(uc) - 1 ;
                     uc &= ~(1LL<<c) ;
                     if (stat == 0 || stat == 27 || stat != c - 26 + 1) {
                        int ns0 = nextstate[s0][c] ;
                        int ns1 = nextstate[s1][c] ;
                        int nstat = (stat > 0 && stat < 27 ? 27 : stat) ;
                        dist[ns0][ns1][nstat] = min(dist[ns0][ns1][nstat], tim+2) ;
                     }
                  }
                  int lc0 = havetrans[s0] >> 26 ;
                  while (lc0) {
                     int c = ffs(lc0) - 1 ;
                     lc0 &= ~(1<<c) ;
                     int ns0 = nextstate[s0][26+c] ;
                     int nstat = (stat == 0 ? 1+c : stat) ;
                     dist[ns0][s1][nstat] = min(dist[ns0][s1][nstat], tim+1) ;
                  }
                  if (stat > 0) {
                     int lc1 = havetrans[s1] >> 26 ;
                     while (lc1) {
                        int c = ffs(lc1) - 1 ;
                        lc1 &= ~(1<<c) ;
                        if (stat != c + 1) {
                           int ns1 = nextstate[s1][26+c] ;
                           int nstat = (stat == c + 1 ? 0 : 27) ;
                           dist[s0][ns1][nstat] = min(dist[s0][ns1][nstat], tim+1) ;
                        }
                     }
                  }
               }
      if (seen == 0 && pseen == 0)
         break ;
      pseen = seen ;
   }
   cout << -1 << endl ;
}
